//+------------------------------------------------------------------+
//|                                                    Iwe_EA V2.mq4 |
//|                                            Copyright  2006, Iwe |
//|                                     http://www.johansetiawan.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Iwe"
#property link      "http://www.johansetiawan.net"
//+------------------------------------------------------------------+
//| Variable List                                                    |
//+------------------------------------------------------------------+
int IDno = 86030810;
string IDtxt = "Iwe EA V10 ICWR";

//extern double step=0.001; //step for ParSar
//extern double max=0.2; //max for ParSar
extern double Lots=0.1; //Lot
extern int Slippage=5; //slippage
extern int StopLoss=50; //SL
extern int TakeProfit=50; //TP
//target1-4 is unused
extern int target1=90;
extern int target2=100;
extern int target3=150;
extern int target4=200;
//extern int range=0;
//extern int range2=0;
extern int TrailingStop=30; //Trailing

extern int activewavepts=40;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

bool FlagOpenBuy,FlagCloseBuy,FlagOpenSell,FlagCloseSell;
bool FlagTradeAfternoon,FlagTradeEvening;
bool FlagTradeEnable;
double profit,sl,tp;
int tiket;
bool temp=true;
double findAW(int mode,int item) //mode : 1 : high, 0 : low //item : 1 value, 0 shift
{
   //Print("AW called");
   double highest=Low[0];
   double lowest=High[0];
   int highestsh,lowestsh,shift;
   for (shift=0;shift<=Bars;shift++)
   {
      if (lowest>iLow(NULL,0,shift))
      {
         lowest=iLow(NULL,0,shift);
         lowestsh=shift;
      }
      
      if (highest<iHigh(NULL,0,shift))
      {
         highest=iHigh(NULL,0,shift);
         highestsh=shift;
      }      
      //Print(highest+"||"+lowest);
      if ((highest-lowest)>=activewavepts*Point)
      {
         //Print("Active wave found");
         break;
      
      }
   }
   if (item==1)
   {
      if (mode==1) return (highest);
      else if (mode==0) return (lowest);
   }
   else if (item==0)
   {
      if (mode==1) return (highestsh);
      else if (mode==0) return (lowestsh);
   }
   else return (0);
}

double getFiboLevel(int mode)
{
   double twentyfive;
   double thirtyeight;
   double sixtyone;
   double seventyfive;
   
   int hsh=findAW(1,0);
   int lsh=findAW(0,0);
   int h=findAW(1,1);
   int l=findAW(0,1);
   
   twentyfive=l+0.25*h;
   thirtyeight=l+0.382*h;
   sixtyone=l+0.618*h;
   seventyfive=l+0.75*h;
   
   if (mode==1) return (twentyfive);
   else if (mode==2) return (thirtyeight);
   else if (mode==3) return (sixtyone);
   else if (mode==4) return (seventyfive);
   else return (0);
   
}
bool trendAW()
{
   if (findAW(1,0)>findAW(0,0)) return (false); //bearish
   else return (true); //bullish
}

int start()
{
                  
   int lmt;
   if (trendAW()) { lmt=findAW(0,0); }
   else { lmt=findAW(1,0); }
   int flagbuy=0;
   int flagsell=0;
   
   //Condition for opening a sell position
   
   for (int shift=0;shift<=lmt;shift++)
   {
      if (iHigh(NULL,0,shift)<getFiboLevel(1))
      {
         flagsell+=1;     
      }
      if (iClose(NULL,0,shift)>getFiboLevel(2))
      {
         flagsell+=1;
      }
      if (flagsell>=2) break;
   }
   FlagOpenSell=flagsell==2 && iRSI(NULL,PERIOD_D1,14,PRICE_CLOSE,0)<50;
   
   
   //Condition for closing a buy position
   for ( shift=0;shift<=lmt;shift++)
   {
      if (iLow(NULL,0,shift)>getFiboLevel(4))
      {
         flagbuy+=1;     
      }
      if (iClose(NULL,0,shift)<getFiboLevel(3))
      {
         flagbuy+=1;
      }
      if (flagbuy>=2) break;
   }
   FlagOpenBuy=flagbuy==2 && iRSI(NULL,PERIOD_D1,14,PRICE_CLOSE,0)>50;
   
   //======================================
   //open this part for following exit strategy from icwr
   //======================================
   
   /*
   
   //Condition for closing a sell position
   FlagCloseSell=FlagOpenBuy
               && temp;   
   //Condition for closing a buy position
   FlagCloseBuy=FlagOpenSell
               && temp;   
   */
   
   //==========================================
   //open this part for following exit with tp 50
   //==========================================
   
   //Condition for closing a sell position
   FlagCloseSell=false
               && temp;   
   //Condition for closing a buy position
   FlagCloseBuy=false
               && temp;   
   
   
   
   //unused.
   //Condition for trade at afternoon
   FlagTradeAfternoon=Hour()>=9 && Hour()<13;
   //Condition for trade at evening
   FlagTradeEvening=Hour()>=15 && Hour()<19;
   //Condition for trading time
   FlagTradeEnable=True;
   
   if (FlagTradeEnable) //check EA active or not 
   {
      if (countOrder(IDno)>0) //if there is an order
      {
         OrderSelect(getOrderTicket(IDno), SELECT_BY_TICKET, MODE_TRADES);                  
         if ((OrderType()==OP_SELL && FlagOpenSell) || (OrderType()==OP_BUY && FlagOpenBuy)) //filled the open condition
            modifySL(IDno); //modify SL
         else if ((OrderType()==OP_SELL && FlagCloseSell) || (OrderType()==OP_BUY && FlagCloseBuy)) //filled the close condition
            //close position
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
               Print("Closing");
            }
      } //end countOrder(IDno)>0
      else
      {
         if (FlagOpenBuy)
         {
            //open a buy position
            if (StopLoss>0) sl=Ask-StopLoss*Point; else sl=0;
            if (TakeProfit>0) tp=Bid+TakeProfit*Point; else tp=0;
            Print("Opening a buy position......");
            tiket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,sl,tp,IDtxt,IDno,0,Red);
            if(tiket>0)
            {
               if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
               // PlaySound(suaraBukaPosisi);

            }
            else 
            {
               Print("Error opening BUY order : ",GetLastError()); 
               // PlaySound(suaraError);
            }
         } //end flagopenbuy
         else if (FlagOpenSell)
         {
            //open a sell position
            if (StopLoss>0) sl=Bid+StopLoss*Point; else sl=0;
            if (TakeProfit>0) tp=Ask-TakeProfit*Point; else tp=0;
            Print("Opening a sell position......");
            tiket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,sl,tp,IDtxt,IDno,0,Orange);
            if(tiket>0)
            {
               if(OrderSelect(tiket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
            //PlaySound(suaraBukaPosisi);
            }
            else 
            {
               Print("Error opening SELL order : ",GetLastError());  
            //PlaySound(suaraError);
            }
         } //end flagopensell
      } //end else countOrder>0
   } //end FlagTradeEnable
   
   return(0);
}
//+------------------------------------------------------------------+

int countOrder(int IDno)
{
    int total;
    for(int cnt=0;cnt<OrdersTotal();cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(  OrderSymbol()==Symbol() &&  
         OrderMagicNumber()==IDno)
            total++;
    
    }
    return (total);
}

int getOrderTicket(int IDno)
{
    for(int cnt=0;cnt<OrdersTotal();cnt++)
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() &&  
         OrderMagicNumber()==IDno)
         {   
            return (OrderTicket());
            break;
         }
      else
         return(0);
    }
}

void modifySL(int IDno)
{
   OrderSelect(getOrderTicket(IDno), SELECT_BY_TICKET, MODE_TRADES);                  
   //Modify SL
   if (OrderType()==OP_SELL)
   {
      profit=(OrderOpenPrice()-Ask)/Point;
      
      if (profit>=target1 && profit<target2) //profit 40
      {
         sl=OrderOpenPrice();
         if (OrderStopLoss()>sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      else if (profit>=target2 && profit<target3) //profit 70
      {
         sl=OrderOpenPrice()-target1*Point;
         if (OrderStopLoss()>sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      else if (profit>=target3 && profit<target4) //profit 100
      {
         sl=OrderOpenPrice()-target2*Point;
         if (OrderStopLoss()>sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      else if (profit>=target4 ) //profit 130
      {
         sl=Ask+TrailingStop*Point;
         if (OrderStopLoss()>sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
   } //end ordertype=sell  
   else if (OrderType()==OP_BUY)
   {
      profit=(Bid-OrderOpenPrice())/Point;
      if (profit>=target1 && profit<target2) //profit 40
      {
         sl=OrderOpenPrice();
         if (OrderStopLoss()<sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      
      else if (profit>=target2 && profit<target3) //profit 70
      {
         sl=OrderOpenPrice()+target1*Point;
         if (OrderStopLoss()<sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      else if (profit>=target3 && profit<target4) //profit 100
      {
         sl=OrderOpenPrice()+target2*Point;
         if (OrderStopLoss()<sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
      
      else if (profit>=target4 ) //profit 130+
      {
         sl=Bid-TrailingStop*Point;
         if (OrderStopLoss()<sl)
            OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Orange);
      }
   }//end ordertype=buy 
}